Index: kdecore/kglobalaccel.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kglobalaccel.cpp,v
retrieving revision 1.89
diff -d -u -p -r1.89 kglobalaccel.cpp
--- kdecore/kglobalaccel.cpp	8 Jan 2003 21:44:15 -0000	1.89
+++ kdecore/kglobalaccel.cpp	5 Mar 2003 05:57:30 -0000
@@ -16,83 +16,254 @@
 KGlobalAccel::KGlobalAccel( QObject* pParent, const char* psName )
 : QObject( pParent, psName )
 {
-	kdDebug(125) << "KGlobalAccel(): this = " << this << endl;
-	d = new KGlobalAccelPrivate();
+    kdDebug(125) << "KGlobalAccel(): this = " << this << endl;
+    d = new KGlobalAccelPrivate();
 }
 
 KGlobalAccel::~KGlobalAccel()
 {
-	kdDebug(125) << "~KGlobalAccel(): this = " << this << endl;
-	delete d;
+    kdDebug(125) << "~KGlobalAccel(): this = " << this << endl;
+    delete d;
 }
 
 /*
 void KGlobalAccel::clear()
-	{ d->clearActions(); }
+{ 
+#ifdef Q_WS_X11
+    d->clearActions(); 
+#endif
+}
 */
+
 KAccelActions& KGlobalAccel::actions()
-	{ return d->actions(); }
+{ 
+#ifdef Q_WS_X11
+    return d->actions(); 
+#else
+    static KAccelActions ret;
+    return ret;
+#endif
+}
 
 const KAccelActions& KGlobalAccel::actions() const
-	{ return d->actions(); }
+{ 
+#ifdef Q_WS_X11
+    return d->actions(); 
+#else
+    static KAccelActions ret;
+    return ret;
+#endif
+}
 
 bool KGlobalAccel::isEnabled()
-	{ return ((KAccelBase*)d)->isEnabled(); }
+{ 
+#ifdef Q_WS_X11
+    return ((KAccelBase*)d)->isEnabled(); 
+#else
+    return false;
+#endif
+}
 
 void KGlobalAccel::setEnabled( bool bEnabled )
-	{ d->setEnabled( bEnabled ); }
+{ 
+#ifdef Q_WS_X11
+    d->setEnabled( bEnabled ); 
+#endif
+}
 
 KAccelAction* KGlobalAccel::insert( const QString& sAction, const QString& sDesc, const QString& sHelp,
 		const KShortcut& cutDef3, const KShortcut& cutDef4,
 		const QObject* pObjSlot, const char* psMethodSlot,
 		bool bConfigurable, bool bEnabled )
 {
-	return d->insert( sAction, sDesc, sHelp,
-		cutDef3, cutDef4,
-		pObjSlot, psMethodSlot,
-		bConfigurable, bEnabled );
+#ifdef Q_WS_X11
+    return d->insert( sAction, sDesc, sHelp, cutDef3, cutDef4, pObjSlot, psMethodSlot,
+		      bConfigurable, bEnabled );
+#else
+	return NULL;
+#endif
 }
 
 KAccelAction* KGlobalAccel::insert( const QString& sName, const QString& sDesc )
-	{ return d->insert( sName, sDesc ); }
+{ 
+#ifdef Q_WS_X11
+    return d->insert( sName, sDesc ); 
+#else
+    return NULL;
+#endif
+}
+
 bool KGlobalAccel::updateConnections()
-	{ return d->updateConnections(); }
+{ 
+#ifdef Q_WS_X11
+    return d->updateConnections(); 
+#else
+    return false;
+#endif
+}
 
 bool KGlobalAccel::remove( const QString& sAction )
-        { return d->remove( sAction ); }
+{ 
+#ifdef Q_WS_X11
+    return d->remove( sAction ); 
+#else
+    return false;
+#endif
+}
 
 const KShortcut& KGlobalAccel::shortcut( const QString& sAction ) const
 {
-	const KAccelAction* pAction = d->actions().actionPtr( sAction );
-	return (pAction) ? pAction->shortcut() : KShortcut::null();
+#ifdef Q_WS_X11
+    const KAccelAction* pAction = d->actions().actionPtr( sAction );
+    return (pAction) ? pAction->shortcut() : KShortcut::null();
+#else
+    return KShortcut::null();
+#endif
 }
 
 bool KGlobalAccel::setShortcut( const QString& sAction, const KShortcut& cut )
-	{ return d->setShortcut( sAction, cut ); }
+{ 
+#ifdef Q_WS_X11
+    return d->setShortcut( sAction, cut ); 
+#else
+    return false;
+#endif
+}
+
 bool KGlobalAccel::setSlot( const QString& sAction, const QObject* pObjSlot, const char* psMethodSlot )
-	{ return d->setActionSlot( sAction, pObjSlot, psMethodSlot ); }
+{ 
+#ifdef Q_WS_X11
+    return d->setActionSlot( sAction, pObjSlot, psMethodSlot ); 
+#else
+    return false;
+#endif
+}
 
 const QString& KGlobalAccel::configGroup() const
-	{ return d->configGroup(); }
+{ 
+#ifdef Q_WS_X11
+    return d->configGroup(); 
+#else
+    return "";
+#endif
+}
+
 // for kdemultimedia/kmix
 void KGlobalAccel::setConfigGroup( const QString& s )
-	{ d->setConfigGroup( s ); }
+{ 
+#ifdef Q_WS_X11
+    d->setConfigGroup( s ); 
+#endif
+}
 
 bool KGlobalAccel::readSettings( KConfigBase* pConfig )
-	{ d->readSettings( pConfig ); return true; }
+{ 
+#ifdef Q_WS_X11
+    d->readSettings( pConfig ); 
+    return true; 
+#else
+    return false;
+#endif
+}
 bool KGlobalAccel::writeSettings( KConfigBase* pConfig ) const
-	{ d->writeSettings( pConfig ); return true; }
+{ 
+#ifdef Q_WS_X11
+    d->writeSettings( pConfig );
+    return true; 
+#else
+    return false;
+#endif
+}
 bool KGlobalAccel::writeSettings( KConfigBase* pConfig, bool bGlobal ) const
 {
-	d->setConfigGlobal( bGlobal );
-	d->writeSettings( pConfig );
-	return true;
+#ifdef Q_WS_X11
+    d->setConfigGlobal( bGlobal );
+    d->writeSettings( pConfig );
+#endif
+    return true;
 }
 
 bool KGlobalAccel::useFourModifierKeys()
-	{ return KAccelAction::useFourModifierKeys(); }
+{ 
+    return KAccelAction::useFourModifierKeys(); 
+}
 
 void KGlobalAccel::virtual_hook( int, void* )
 { /*BASE::virtual_hook( id, data );*/ }
+
+
+#ifdef Q_WS_MAC
+/* This is all temporary, I've just placed some stubs here to get things building,
+   I will come back and implement these (and in the appropriate files) later. --Sam Magnuson
+*/
+KKeySequence::KKeySequence(const KKeyNative &)
+{
+    clear();
+}
+KKeyNative::KKeyNative(const KKey &)
+{
+}
+KKeyNative::KKeyNative()
+{
+}
+KKeyNative::~KKeyNative()
+{
+}
+void
+KKey::simplify()
+{
+}
+KKey
+KKeyNative::key() const
+{
+    return KKey();
+}
+int
+KKeyNative::keyCodeQt() const
+{
+    return 0;
+}
+bool
+KKeyNative::keyboardHasWinKey()
+{
+    return false;
+}
+KGlobalAccelPrivate::KGlobalAccelPrivate()
+{
+}
+void 
+KGlobalAccelPrivate::setEnabled( bool )
+{
+}
+bool 
+KGlobalAccelPrivate::connectKey( KAccelAction&, KKeySequence )
+{
+    return false;
+}
+bool 
+KGlobalAccelPrivate::disconnectKey( KAccelAction&, KKeySequence )
+{
+    return false;
+}
+bool
+KKeyServer::Key::init(const KKey &, bool)
+{
+    return false;
+}
+int 
+KKeyServer::Key::compare( const Key& key ) const
+{
+    return 0;
+}
+KKey
+KKeyServer::Key::key() const
+{
+    return KKey();
+}
+void
+KKeyServer::Variations::init(const KKey &, bool)
+{
+}
+#endif
 
 #include "kglobalaccel.moc"
Index: kdecore/kiconeffect.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kiconeffect.cpp,v
retrieving revision 1.44
diff -d -u -p -r1.44 kiconeffect.cpp
--- kdecore/kiconeffect.cpp	21 Nov 2002 19:18:51 -0000	1.44
+++ kdecore/kiconeffect.cpp	5 Mar 2003 05:57:31 -0000
@@ -360,7 +360,11 @@ void KIconEffect::semiTransparent(QImage
 	int width  = img.width();
 	int height = img.height();
 	
+#ifdef Q_WS_X11
 	if (qt_use_xrender && qt_has_xft )
+#else
+	if (true)
+#endif
 	  for (y=0; y<height; y++)
 	  {
 #ifdef WORDS_BIGENDIAN
@@ -426,7 +430,11 @@ void KIconEffect::semiTransparent(QImage
 
 void KIconEffect::semiTransparent(QPixmap &pix)
 {
+#ifdef Q_WS_X11
     if ( qt_use_xrender && qt_has_xft )
+#else
+    if ( true )
+#endif
     {
 	QImage img=pix.convertToImage();
 	semiTransparent(img);
Index: kdecore/kipc.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kipc.cpp,v
retrieving revision 1.11
diff -d -u -p -r1.11 kipc.cpp
--- kdecore/kipc.cpp	29 Aug 2001 15:25:38 -0000	1.11
+++ kdecore/kipc.cpp	5 Mar 2003 05:57:33 -0000
@@ -36,7 +36,7 @@
 #include <kipc.h>
 
 
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
 static int dropError(Display *, XErrorEvent *)
 {
     return 0;
@@ -113,5 +113,8 @@ void KIPC::sendMessageAll(Message msg, i
     XFree((char *) rootwins);
 }
 #else
-	// FIXME(E): Implement in Qt Embedded
+void KIPC::sendMessageAll(Message msg, int data)
+{
+}
+// FIXME(E): Implement in QWS & MAC
 #endif
Index: kdecore/klibloader.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/klibloader.cpp,v
retrieving revision 1.61
diff -d -u -p -r1.61 klibloader.cpp
--- kdecore/klibloader.cpp	26 Feb 2003 17:59:32 -0000	1.61
+++ kdecore/klibloader.cpp	5 Mar 2003 05:57:33 -0000
@@ -539,7 +539,7 @@ void KLibLoader::close_pending(KLibWrapP
 
 //    kdDebug(150) << "try to dlclose " << wrap->name << ": yes, done." << endl;
 
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
     if ( !deleted_one ) {
       /* Only do the hack once in this loop.
          WABA: *HACK*
@@ -565,7 +565,7 @@ void KLibLoader::close_pending(KLibWrapP
       delete widgetlist;
     }
 #else
-    // FIXME(E): Implement in Qt Embedded
+    // FIXME(E): Implement in QWS & MAC
 #endif
 
     deleted_one = true;
Index: kdecore/kprocess.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kprocess.cpp,v
retrieving revision 1.119
diff -d -u -p -r1.119 kprocess.cpp
--- kdecore/kprocess.cpp	24 Feb 2003 21:23:34 -0000	1.119
+++ kdecore/kprocess.cpp	5 Mar 2003 05:57:34 -0000
@@ -69,6 +69,7 @@
 #include <pwd.h>
 #include <grp.h>
 
+#include <qdir.h>
 #include <qfile.h>
 #include <qsocketnotifier.h>
 #include <qapplication.h>
@@ -372,7 +373,23 @@ bool KProcess::start(RunMode runmode, Co
         const char *executable = arglist[0];
         if (!d->executable.isEmpty())
            executable = d->executable.data();
-        execvp(executable, arglist);
+#ifdef Q_OS_MACX
+	/* This tries to find the executable in an application bundle */
+	{
+	    QString bundle = executable;
+	    bundle += ".app/Contents/MacOS/" + bundle.section('/', -1);
+	    if(QFile::exists(bundle)) {
+		QFileInfo fileInfo(bundle);
+		if(fileInfo.isExecutable()) {
+		    QCString cstr(fileInfo.absFilePath().local8Bit());
+		    execvp(cstr.data(), arglist);
+		    executable = NULL;
+		}
+	    }
+	}
+#endif
+	if(executable) 
+	    execvp(executable, arglist);
 
         char resultByte = 1;
         write(fd[1], &resultByte, 1);
Index: kdecore/krootprop.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/krootprop.cpp,v
retrieving revision 1.29
diff -d -u -p -r1.29 krootprop.cpp
--- kdecore/krootprop.cpp	28 Oct 2001 11:59:58 -0000	1.29
+++ kdecore/krootprop.cpp	5 Mar 2003 05:57:35 -0000
@@ -18,7 +18,7 @@
 */
 
 #include <qwidget.h>
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
 #include "krootprop.h"
 #include "kglobal.h"
 #include "klocale.h"
@@ -295,4 +295,6 @@ QStringList KRootProp::listEntries() con
 	
     return list;
 }
+#else
+    // FIXME(E): Implement in QWS & MAC
 #endif
Index: kdecore/kshortcut.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kshortcut.cpp,v
retrieving revision 1.20
diff -d -u -p -r1.20 kshortcut.cpp
--- kdecore/kshortcut.cpp	25 Feb 2003 16:59:50 -0000	1.20
+++ kdecore/kshortcut.cpp	5 Mar 2003 05:57:35 -0000
@@ -68,6 +68,7 @@ bool KKey::init( uint key, uint modFlags
 
 bool KKey::init( int keyQt )
 {
+#ifdef Q_WS_X11
 	//KKeyServer::Sym sym;
 
 	//if( sym.initQt( keyQt )
@@ -79,6 +80,12 @@ bool KKey::init( int keyQt )
 		m_mod = 0;
 		return false;
 	}
+#else
+	// FIXME: Implement on QWS & MAC
+	m_sym = keyQt | Qt::MODIFIER_MASK;
+	m_mod = keyQt & Qt::MODIFIER_MASK;
+#endif
+	return true;
 }
 
 bool KKey::init( const QKeySequence& key )
@@ -105,6 +112,7 @@ bool KKey::init( const KKey& key )
 
 bool KKey::init( const QString& sSpec )
 {
+#ifdef Q_WS_X11
 	clear();
 
 	QString sKey = sSpec.stripWhiteSpace();
@@ -140,6 +148,9 @@ bool KKey::init( const QString& sSpec )
 		<< ", m_mod = " << QString::number(m_mod, 16) << endl;
 
 	return m_sym != 0;
+#else
+	return init(QKeySequence(sSpec));
+#endif
 }
 
 bool KKey::isNull() const          { return m_sym == 0; }
@@ -163,12 +174,14 @@ int KKey::keyCodeQt() const
 QString KKey::toString() const
 {
 	QString s;
-
+#ifdef Q_WS_X11
 	s = KKeyServer::modToStringUser( m_mod );
 	if( !s.isEmpty() )
 		s += '+';
 	s += KKeyServer::Sym(m_sym).toString();
-
+#else
+	s += (QString)QKeySequence(m_mod | m_sym);
+#endif
 	return s;
 }
 
@@ -178,11 +191,14 @@ QString KKey::toStringInternal() const
 	//	<< " mod = " << QString::number(m_mod, 16)
 	//	<< " key = " << QString::number(m_sym, 16) << endl;
 	QString s;
-
+#ifdef Q_WS_X11
 	s = KKeyServer::modToStringInternal( m_mod );
 	if( !s.isEmpty() )
 		s += '+';
 	s += KKeyServer::Sym(m_sym).toStringInternal();
+#else
+	s += toString();
+#endif
 	return s;
 }
 
@@ -197,7 +213,12 @@ KKey& KKey::null()
 
 QString KKey::modFlagLabel( ModFlag modFlag )
 {
+#ifdef Q_WS_X11
 	return KKeyServer::modToStringUser( modFlag );
+#else
+	// FIXME: Implement on QWS & MAC
+	return QString();
+#endif
 }
 
 //---------------------------------------------------------------------
@@ -312,8 +333,9 @@ bool KKeySequence::setKey( uint iKey, co
 {
 	if( iKey <= m_nKeys && iKey < MAX_KEYS ) {
 		m_rgvar[iKey].init( key );
-		if( iKey == m_nKeys )
+		if( iKey == m_nKeys ) {
 			m_nKeys++;
+		}
 		return true;
 	} else
 		return false;
@@ -471,39 +493,25 @@ bool KShortcut::init( const KShortcut& c
 
 bool KShortcut::init( const QString& s )
 {
+
 	bool bRet = true;
 	QStringList rgs = QStringList::split( ';', s );
 
-	if( s == "none" || rgs.size() == 0 )
-		clear();
-	else if( rgs.size() <= MAX_SEQUENCES ) {
-		m_nSeqs = rgs.size();
-		for( uint i = 0; i < m_nSeqs; i++ ) {
-			QString& sSeq = rgs[i];
-			if( sSeq.startsWith( "default(" ) )
-				sSeq = sSeq.mid( 8, sSeq.length() - 9 );
-			m_rgseq[i].init( sSeq );
-			//kdDebug(125) << "*\t'" << sSeq << "' => " << m_rgseq[i].toStringInternal() << endl;
-		}
+	if( s == "none" || rgs.size() == 0 ) {
+	    clear();
+	} else if( rgs.size() <= MAX_SEQUENCES ) {
+	    m_nSeqs = rgs.size();
+	    for( uint i = 0; i < m_nSeqs; i++ ) {
+		QString& sSeq = rgs[i];
+		if( sSeq.startsWith( "default(" ) )
+		    sSeq = sSeq.mid( 8, sSeq.length() - 9 );
+		m_rgseq[i].init( sSeq );
+		//kdDebug(125) << "*\t'" << sSeq << "' => " << m_rgseq[i].toStringInternal() << endl;
+	    }
 	} else {
-		clear();
-		bRet = false;
-	}
-
-	if( !s.isEmpty() ) {
-		QString sDebug;
-		QTextStream os( &sDebug, IO_WriteOnly );
-		os << "KShortcut::init( \"" << s << "\" ): ";
-		for( uint i = 0; i < m_nSeqs; i++ ) {
-			os << " m_rgseq[" << i << "]: ";
-			KKeyServer::Variations vars;
-			vars.init( m_rgseq[i].key(0), true );
-			for( uint j = 0; j < vars.count(); j++ )
-				os << QString::number(vars.m_rgkey[j].keyCodeQt(),16) << ',';
-		}
-		kdDebug(125) << sDebug << endl;
+	    clear();
+	    bRet = false;
 	}
-
 	return bRet;
 }
 
@@ -572,7 +580,7 @@ bool KShortcut::setSeq( uint iSeq, const
 	// TODO: check if seq is null, and act accordingly.
 	if( iSeq <= m_nSeqs && iSeq < MAX_SEQUENCES ) {
 		m_rgseq[iSeq] = seq;
-		if( iSeq == m_nSeqs )
+		if( iSeq == m_nSeqs ) 
 			m_nSeqs++;
 		return true;
 	} else
Index: kdecore/kuniqueapplication.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kuniqueapplication.cpp,v
retrieving revision 1.52
diff -d -u -p -r1.52 kuniqueapplication.cpp
--- kdecore/kuniqueapplication.cpp	15 Apr 2002 19:20:04 -0000	1.52
+++ kdecore/kuniqueapplication.cpp	5 Mar 2003 05:57:36 -0000
@@ -45,8 +45,10 @@
 #ifdef Q_WS_X11
 #include <X11/Xlib.h>
 #define DISPLAY "DISPLAY"
-#else
+#elif defined(Q_WS_QWS)
 #define DISPLAY "QWS_DISPLAY"
+#elif defined(Q_WS_MAC)
+//We don't use DISPLAY on Qt/Mac!! --Sam
 #endif
 
 bool KUniqueApplication::s_nofork = false;
@@ -112,7 +114,15 @@ KUniqueApplication::start()
      kdError() << "KUniqueApplication: pipe() failed!" << endl;
      ::exit(255);
   }
+#ifdef Q_OS_MAC
+  /* I don't have a complete explanation of why vfork is neccesary here (for Mac OS X only).
+     What I was experiencing was the fork would cause the stack to be copied, and since this
+     happens from the constructor it lead to some evil recursion that resulted in a call to
+     Carbon (creating the desktop widgets I believe) that then caused the child process to crash */
+  int fork_result = vfork();
+#else
   int fork_result = fork();
+#endif
   switch(fork_result) {
   case -1:
      kdError() << "KUniqueApplication: fork() failed!" << endl;
@@ -132,6 +142,7 @@ KUniqueApplication::start()
         QCString regName = dc->registerAs(appName, false);
         if (regName.isEmpty())
         {
+#ifndef Q_WS_MAC
            // Check DISPLAY
            if (QCString(getenv(DISPLAY)).isEmpty())
            {
@@ -140,6 +151,7 @@ KUniqueApplication::start()
               ::write(fd[1], &result, 1);
               ::exit(255);
            }
+#endif
 
            // Try to launch kdeinit.
            startKdeinit();
@@ -176,7 +188,7 @@ KUniqueApplication::start()
                    XCloseDisplay( disp );
                }
            }
-#else //FIXME(E): implement
+#else //FIXME(E): implement on QWS & MAC
 #endif
            return false;
         }
@@ -200,7 +212,7 @@ KUniqueApplication::start()
                XCloseDisplay( disp );
                }
          }
-#else //FIXME(E): Implement
+#else //FIXME(E): Implement on QWS & MAC
 #endif
      }
      result = 0;
@@ -260,6 +272,7 @@ KUniqueApplication::start()
         delete dc;	// Clean up DCOP commmunication
         ::exit(255);
      }
+
      if (replyType != "int")
      {
         kdError() << "KUniqueApplication: DCOP communication error!" << endl;
@@ -376,9 +389,11 @@ int KUniqueApplication::newInstance()
 {
   if (!d->firstInstance)
   {
-#ifndef Q_WS_QWS // FIXME(E): Implement for Qt/Embedded
+#ifdef Q_WS_X11
      if ( mainWidget() )
         KWin::setActiveWindow(mainWidget()->winId());
+#else
+     // FIXME(E): Implement for QWS & MAC
 #endif
   }
   d->firstInstance = false;
Index: kdecore/kwin.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdecore/kwin.cpp,v
retrieving revision 1.60
diff -d -u -p -r1.60 kwin.cpp
--- kdecore/kwin.cpp	21 Feb 2003 16:01:54 -0000	1.60
+++ kdecore/kwin.cpp	5 Mar 2003 05:57:37 -0000
@@ -32,7 +32,7 @@
 #include <qwhatsthis.h>
 #include <qcstring.h>
 
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
 #include "kwin.h"
 #include "kapplication.h"
 
@@ -479,4 +479,6 @@ void KWin::appStarted()
 
 // Fix for --enable-final. This gets defined at the top of this file.
 #undef	None
+#else
+     // FIXME(E): Implement for QWS & MAC
 #endif
Index: kdefx/kstyle.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdefx/kstyle.cpp,v
retrieving revision 1.34
diff -d -u -p -r1.34 kstyle.cpp
--- kdefx/kstyle.cpp	23 Feb 2003 16:23:26 -0000	1.34
+++ kdefx/kstyle.cpp	5 Mar 2003 05:57:40 -0000
@@ -51,11 +51,15 @@
 #include <kimageeffect.h>
 #include "kstyle.h"
 
+#ifdef Q_WS_X11
 #include <X11/Xlib.h>
 #ifdef HAVE_XRENDER
 #include <X11/extensions/Xrender.h>
 extern bool qt_use_xrender;
 #endif
+#else
+#define qt_xrootwin QApplication::desktop()->winId
+#endif
 
 #include <limits.h>
 
@@ -1899,8 +1903,10 @@ void TransparencyHandler::createShadowWi
 	se.w2 = new QWidget(0, 0, WStyle_Customize | WType_Popup | WX11BypassWM );
 	se.w1->setGeometry(shadow1);
 	se.w2->setGeometry(shadow2);
+#ifdef Q_WS_X11
 	XSelectInput(qt_xdisplay(), se.w1->winId(), StructureNotifyMask );
 	XSelectInput(qt_xdisplay(), se.w2->winId(), StructureNotifyMask );
+#endif
 
 	// Insert a new ShadowMap entry
 	shadowMap()[p] = se;
@@ -1923,10 +1929,15 @@ void TransparencyHandler::createShadowWi
 	se.w1->setErasePixmap(pix_shadow1);
 	se.w2->setErasePixmap(pix_shadow2);
 
+#ifdef Q_WS_X11
 	// Show the 'shadow' just before showing the popup menu window
 	// Don't use QWidget::show() so we don't confuse QEffects, thus causing broken focus.
 	XMapWindow(qt_xdisplay(), se.w1->winId());
 	XMapWindow(qt_xdisplay(), se.w2->winId());
+#else
+	se.w1->show();
+	se.w2->show();
+#endif
 }
 
 void TransparencyHandler::removeShadowWindows(const QPopupMenu* p)
@@ -1935,9 +1946,14 @@ void TransparencyHandler::removeShadowWi
 	if (it != shadowMap().end())
 	{
 		ShadowElements se = it.data();
+#ifdef Q_WS_X11
 		XUnmapWindow(qt_xdisplay(), se.w1->winId());	// hide
 		XUnmapWindow(qt_xdisplay(), se.w2->winId());
 		XFlush(qt_xdisplay());							// try to hide faster
+#else
+		se.w1->hide();
+		se.w2->hide();
+#endif
 		delete se.w1;
 		delete se.w2;
 		shadowMap().erase(it);
@@ -1962,15 +1978,13 @@ bool TransparencyHandler::eventFilter( Q
 					p->x(), p->y(), p->width(), p->height());
 
 			switch (te) {
-#ifdef HAVE_XRENDER
 				case XRender:
+#ifdef HAVE_XRENDER
 					if (qt_use_xrender) {
 						XRenderBlendToPixmap(p);
 						break;
 					}
 					// Fall through intended
-#else
-				case XRender:
 #endif
 				case SoftwareBlend:
 					blendToPixmap(p->colorGroup(), p);
Index: kdeprint/Makefile.am
===================================================================
RCS file: /home/kde/kdelibs/kdeprint/Makefile.am,v
retrieving revision 1.64
diff -d -u -p -r1.64 Makefile.am
--- kdeprint/Makefile.am	29 Dec 2002 13:27:47 -0000	1.64
+++ kdeprint/Makefile.am	5 Mar 2003 05:57:40 -0000
@@ -10,7 +10,7 @@ INCLUDES= -I$(top_srcdir)/kdefx -I$(top_
 kde_module_LTLIBRARIES = kded_kdeprintd.la
 
 kded_kdeprintd_la_SOURCES = kdeprintd.skel kdeprintd.cpp kprintprocess.cpp
-kded_kdeprintd_la_LIBADD = $(LIB_KIO)
+kded_kdeprintd_la_LIBADD = $(LIB_KIO) $(top_builddir)/kded/kded.la
 kded_kdeprintd_la_LDFLAGS = $(all_libraries) -module -avoid-version
 #kded_kdeprintd_la_METASOURCES = AUTO
 
Index: kdeprint/kdeprintd.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeprint/kdeprintd.cpp,v
retrieving revision 1.13
diff -d -u -p -r1.13 kdeprintd.cpp
--- kdeprint/kdeprintd.cpp	10 Feb 2003 15:54:02 -0000	1.13
+++ kdeprint/kdeprintd.cpp	5 Mar 2003 05:57:40 -0000
@@ -72,7 +72,9 @@ StatusWindow::StatusWindow(int pid)
 	m_icon = new QLabel(this);
 	m_icon->setPixmap(DesktopIcon("fileprint"));
 	m_icon->setAlignment(AlignCenter);
+#ifdef Q_WS_X11
 	KWin::setIcons(winId(), *(m_icon->pixmap()), SmallIcon("fileprint"));
+#endif
 	QGridLayout	*l0 = new QGridLayout(this, 2, 3, 10, 10);
 	l0->setRowStretch(0, 1);
 	l0->setColStretch(1, 1);
Index: kdeprint/management/kmjobviewer.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeprint/management/kmjobviewer.cpp,v
retrieving revision 1.38
diff -d -u -p -r1.38 kmjobviewer.cpp
--- kdeprint/management/kmjobviewer.cpp	1 Oct 2002 09:10:44 -0000	1.38
+++ kdeprint/management/kmjobviewer.cpp	5 Mar 2003 05:57:42 -0000
@@ -148,7 +148,9 @@ void KMJobViewer::updateCaption()
 	{
 		setCaption(i18n("No Printer"));
 	}
+#ifdef Q_WS_X11
 	KWin::setIcons(winId(), DesktopIcon(pixname), SmallIcon(pixname));
+#endif
 }
 
 void KMJobViewer::updateStatusBar()
Index: kdeui/kcolorbutton.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kcolorbutton.cpp,v
retrieving revision 1.33
diff -d -u -p -r1.33 kcolorbutton.cpp
--- kdeui/kcolorbutton.cpp	10 Jan 2003 01:29:45 -0000	1.33
+++ kdeui/kcolorbutton.cpp	5 Mar 2003 05:57:43 -0000
@@ -154,6 +154,7 @@ void KColorButton::mouseMoveEvent( QMous
 void KColorButton::chooseColor()
 {
   QColor c = color();
+#ifdef Q_WS_X11
   if ( d->m_bdefaultColor )
   {
       if( KColorDialog::getColor( c, d->m_defaultColor, this ) != QDialog::Rejected ) {
@@ -161,6 +162,7 @@ void KColorButton::chooseColor()
       }
   }
   else
+#endif
   {
       if( KColorDialog::getColor( c, this ) != QDialog::Rejected ) {
           setColor( c );
Index: kdeui/kcolordialog.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kcolordialog.cpp,v
retrieving revision 1.95
diff -d -u -p -r1.95 kcolordialog.cpp
--- kdeui/kcolordialog.cpp	27 Feb 2003 20:59:19 -0000	1.95
+++ kdeui/kcolordialog.cpp	5 Mar 2003 05:57:45 -0000
@@ -64,12 +64,16 @@
 #include <config.h>
 #include <kdebug.h>
 
+#ifndef Q_WS_QWS
 #ifdef Q_WS_X11
 #include <X11/Xlib.h>
 
 // defined in qapplication_x11.cpp
 typedef int (*QX11EventFilter) (XEvent*);
 extern QX11EventFilter qt_set_x11_event_filter (QX11EventFilter filter);
+#elif defined(Q_WS_MAC)
+# include "qcolordialog.h"
+#endif
 
 #define HSV_X 305
 #define RGB_X 385
@@ -890,7 +894,9 @@ public:
     QCheckBox *cbDefaultColor;
     KColor defaultColor;
     KColor selColor;
+#ifdef Q_WS_X11
     QX11EventFilter oldfilter;
+#endif
 };
 
 
@@ -902,7 +908,9 @@ KColorDialog::KColorDialog( QWidget *par
   d = new KColorDialogPrivate;
   d->bRecursion = true;
   d->bColorPicking = false;
+#ifdef Q_WS_X11
   d->oldfilter = 0;
+#endif
   d->cbDefaultColor = 0L;
   setHelp( QString::fromLatin1("kcolordialog.html"), QString::null );
   connect( this, SIGNAL(okClicked(void)),this,SLOT(slotWriteSettings(void)));
@@ -1125,8 +1133,10 @@ KColorDialog::KColorDialog( QWidget *par
 
 KColorDialog::~KColorDialog()
 {
+#ifdef Q_WS_X11
     if (d->bColorPicking)
         qt_set_x11_event_filter(d->oldfilter);
+#endif
     delete d;
 }
 
@@ -1233,6 +1243,16 @@ void KColorDialog::setColor( const QColo
 //
 int KColorDialog::getColor( QColor &theColor, QWidget *parent )
 {
+#ifdef Q_WS_MAC
+    //I want mac's color dialog because it will look like a native app!
+    QColor ret = QColorDialog::getColor(theColor, parent);
+    if(ret.isValid()) {
+	theColor = ret;
+	return Accepted;
+    }
+    return Rejected;
+#endif
+
   KColorDialog dlg( parent, "Color Selector", TRUE );
   if ( theColor.isValid() )
     dlg.setColor( theColor );
@@ -1251,6 +1271,16 @@ int KColorDialog::getColor( QColor &theC
 //
 int KColorDialog::getColor( QColor &theColor, const QColor& defaultCol, QWidget *parent )
 {
+#ifdef Q_WS_MAC
+    //I want mac's color dialog because it will look like a native app!
+    QColor ret = QColorDialog::getColor(theColor, parent);
+    if(ret.isValid()) {
+	theColor = ret;
+	return Accepted;
+    }
+    return Rejected;
+#endif
+
   KColorDialog dlg( parent, "Color Selector", TRUE );
   dlg.setDefaultColor( defaultCol );
   dlg.setColor( theColor );
@@ -1404,6 +1434,7 @@ void KColorDialog::showColor( const KCol
 
 static QWidget *kde_color_dlg_widget = 0;
 
+#ifdef Q_WS_X11
 int kde_color_dlg_handler(XEvent *event)
 {
     if (event->type == ButtonRelease)
@@ -1415,12 +1446,15 @@ int kde_color_dlg_handler(XEvent *event)
     }
     return FALSE;
 }
+#endif
 
 void
 KColorDialog::slotColorPicker()
 {
     d->bColorPicking = true;
+#ifdef Q_WS_X11
     d->oldfilter = qt_set_x11_event_filter(kde_color_dlg_handler);
+#endif
     kde_color_dlg_widget = this;
     grabMouse( crossCursor );
     grabKeyboard();
@@ -1432,8 +1466,10 @@ KColorDialog::mouseReleaseEvent( QMouseE
   if (d->bColorPicking)
   {
      d->bColorPicking = false;
+#ifdef Q_WS_X11
      qt_set_x11_event_filter(d->oldfilter);
      d->oldfilter = 0;
+#endif
      releaseMouse();
      releaseKeyboard();
      _setColor( grabColor( e->globalPos() ) );
@@ -1459,8 +1495,10 @@ KColorDialog::keyPressEvent( QKeyEvent *
      if (e->key() == Key_Escape)
      {
         d->bColorPicking = false;
+#ifdef Q_WS_X11
         qt_set_x11_event_filter(d->oldfilter);
         d->oldfilter = 0;
+#endif
         releaseMouse();
         releaseKeyboard();
      }
@@ -1522,6 +1560,5 @@ void KColorPatch::virtual_hook( int, voi
 void KColorDialog::virtual_hook( int id, void* data )
 { KDialogBase::virtual_hook( id, data ); }
 
-
 #include "kcolordialog.moc"
-#endif
+#endif //Q_WS_QWS
Index: kdeui/kcolordialog.h
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kcolordialog.h,v
retrieving revision 1.50
diff -d -u -p -r1.50 kcolordialog.h
--- kdeui/kcolordialog.h	1 Aug 2002 14:19:52 -0000	1.50
+++ kdeui/kcolordialog.h	5 Mar 2003 05:57:46 -0000
@@ -25,11 +25,12 @@
 #ifndef __KCOLORDIALOG_H__
 #define __KCOLORDIALOG_H__
 
-#ifdef Q_WS_QWS
+#if defined( Q_WS_QWS )
 // FIXME(E): Do we need the KColorDialog extra functionality in Qt Embedded?
 #include <qcolordialog.h>
 #define KColorDialog QColorDialog
 #else
+
 #include <kdialogbase.h>
 #include <qframe.h>
 #include <qpixmap.h>
Index: kdeui/khelpmenu.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/khelpmenu.cpp,v
retrieving revision 1.52
diff -d -u -p -r1.52 khelpmenu.cpp
--- kdeui/khelpmenu.cpp	19 Feb 2003 15:27:41 -0000	1.52
+++ kdeui/khelpmenu.cpp	5 Mar 2003 05:57:47 -0000
@@ -277,7 +277,7 @@ void KHelpMenu::contextHelpActivated()
   QWidget* w = QApplication::widgetAt( QCursor::pos(), TRUE );
   while ( w && !w->isTopLevel() && !w->inherits("QXEmbed")  )
       w = w->parentWidget();
-#ifndef Q_WS_QWS
+#if !defined( Q_WS_QWS ) && !defined( Q_WS_MAC )
    if ( w && w->inherits("QXEmbed") )
 	  (( QXEmbed*) w )->enterWhatsThisMode();
 #endif
Index: kdeui/kiconview.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kiconview.cpp,v
retrieving revision 1.57
diff -d -u -p -r1.57 kiconview.cpp
--- kdeui/kiconview.cpp	4 Mar 2002 00:51:49 -0000	1.57
+++ kdeui/kiconview.cpp	5 Mar 2003 05:57:47 -0000
@@ -160,13 +160,14 @@ void KIconView::slotAutoSelect()
     setFocus();
 
 #ifdef Q_WS_X11
-  //FIXME(E): Implement for Qt Embedded
   Window root;
   Window child;
   int root_x, root_y, win_x, win_y;
   uint keybstate;
   XQueryPointer( qt_xdisplay(), qt_xrootwin(), &root, &child,
 		 &root_x, &root_y, &win_x, &win_y, &keybstate );
+#else
+      //FIXME: Implement (QWS & MAC) 
 #endif
 
   QIconViewItem* previousItem = currentItem();
@@ -557,9 +558,11 @@ void KIconViewItem::paintItem( QPainter 
                 QPixmap selectedPix = kview->selectedIconPixmap( pix, cg.highlight() );
                 p->drawPixmap( iconX, iconY, selectedPix );
             }
+
         } else {
             p->drawPixmap( iconX, iconY, *pix );
         }
+
     }
 
     if ( isSelected() ) {
Index: kdeui/klistbox.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/klistbox.cpp,v
retrieving revision 1.18
diff -d -u -p -r1.18 klistbox.cpp
--- kdeui/klistbox.cpp	4 Mar 2002 00:51:50 -0000	1.18
+++ kdeui/klistbox.cpp	5 Mar 2003 05:57:48 -0000
@@ -131,14 +131,14 @@ void KListBox::slotAutoSelect()
   setCurrentItem( m_pCurrentItem );
 
   if( m_pCurrentItem ) {
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
     //Shift pressed?
     if( (keybstate & ShiftMask) ) {
 #endif
       bool block = signalsBlocked();
       blockSignals( true );
 
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
       //No Ctrl? Then clear before!
       if( !(keybstate & ControlMask) )  
 	clearSelection(); 
@@ -171,7 +171,7 @@ void KListBox::slotAutoSelect()
       if( selectionMode() == QListBox::Single )
 	emit selectionChanged( m_pCurrentItem );
     }
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
     else if( (keybstate & ControlMask) )
       setSelected( m_pCurrentItem, !m_pCurrentItem->isSelected() );
 #endif
@@ -186,7 +186,7 @@ void KListBox::slotAutoSelect()
 
       setSelected( m_pCurrentItem, true );
     }
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
   }
   else
     kdDebug() << "That´s not supposed to happen!!!!" << endl;
@@ -206,15 +206,14 @@ void KListBox::emitExecute( QListBoxItem
     
   m_pAutoSelect->stop();
   
-#ifndef Q_WS_QWS //FIXME
-  //Don´t emit executed if in SC mode and Shift or Ctrl are pressed
-  if( !( m_bUseSingle && ((keybstate & ShiftMask) || (keybstate & ControlMask)) ) ) {
+#ifdef Q_WS_X11 //FIXME
+  //Don't emit executed if in SC mode and Shift or Ctrl are pressed
+  if( !( m_bUseSingle && ((keybstate & ShiftMask) || (keybstate & ControlMask)) ) ) 
 #endif
+  {
     emit executed( item );
     emit executed( item, pos );
-#ifndef Q_WS_QWS //FIXME
   }
-#endif
 }
 
 //
